/******************************************************************************

JMixNet - A Java MixNet Implementation

Fabiano Castro Pereira
LabSEC - Computer Security Laboratory (www.labsec.ufsc.br)
Informatics and Statistics Department (www.inf.ufsc.br)
Federal University of Santa Catarina  (www.ufsc.br)  
Florianopolis, Santa Catarina, Brazil

JMixNet is a registered trademark of the Federal University of Santa Catarina.
No commercial use of this trademark may be made without prior written
permission of the Federal University of Santa Catarina.\

******************************************************************************/
package br.edu.ufsc.labsec.farnel;

import java.applet.Applet;

import br.edu.ufsc.labsec.jmixnet.JMixNetClient;
import br.edu.ufsc.labsec.jmixnet.JMixNetException;

/**
 * @author castro
 *
 * Applet to send the vote thru the mixnet.
 */
public class JMixNetApplet extends Applet {
    
    protected JMixNetClient mixClient;

	private java.awt.Label label = null;  //  @jve:visual-info  decl-index=0 visual-constraint="18,20"
    /**
     * This is the default constructor
     */
    public JMixNetApplet() {
        super();
        init();
    }

    /**
     * This method initializes this JMixNet applet
     * 
     * @return void
     */
    public void init() {
        try {
            //create mix client
            mixClient = new JMixNetClient(JMixNetApplet.class.getClassLoader().getResourceAsStream("farnel-jmixnet.cfg"));

mixClient.connect();
mixClient.sendData("dsa".getBytes(), 3);//UNDO
mixClient.disconnect();
        }
        catch (JMixNetException ex) {
            System.err.println("Unable to create JMixNet client. Details:" + ex.getMessage());
        }
    }
    
    public void sendVote() {
        String vote = getParameter("voto");
        try {
            mixClient.connect();
            mixClient.sendData(vote.getBytes(), vote.length());
            mixClient.disconnect();
        }
        catch (JMixNetException ex) {
            System.err.println("Unable to send the vote. Details:" + ex.getMessage());
        }
    }
	/**
	 * This method initializes label
	 * 
	 * @return java.awt.Label
	 */
	private java.awt.Label getLabel() {
		if(label == null) {
			label = new java.awt.Label();
			label.setText("Teste de label");
		}
		return label;
	}
}