/******************************************************************************

JMixNet - A Java MixNet Implementation

Fabiano Castro Pereira
LabSEC - Computer Security Laboratory (www.labsec.ufsc.br)
Informatics and Statistics Department (www.inf.ufsc.br)
Federal University of Santa Catarina  (www.ufsc.br)  
Florianopolis, Santa Catarina, Brazil

JMixNet is a registered trademark of the Federal University of Santa Catarina.
No commercial use of this trademark may be made without prior written
permission of the Federal University of Santa Catarina.\

******************************************************************************/
package br.edu.ufsc.labsec.farnel.jmixnet;

import java.io.*;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.nio.ByteBuffer;

import br.edu.ufsc.labsec.jmixnet.MessageDeliverer;

/**
 * @author castro
 *
 * Delivers votes from farnel protocol handled by a JMixNet.
 */
public class VoteDeliverer implements MessageDeliverer {

    protected PrintStream errorReport = System.err;
    protected URL url;
    protected HttpURLConnection connection;
    protected short voteSize;
    protected String vote;
    protected int fooInt;
    
    public VoteDeliverer() {
        try {
            url = new URL("http://votacaodigital.labsec.ufsc.br/seguranca/protocolos/farnel/entrega.php");
        }
        catch (MalformedURLException e) {
            e.printStackTrace();
        }
    }

    /* (non-Javadoc)
     * @see br.edu.ufsc.labsec.jmixnet.MessageDeliverer#deliverMsg(java.nio.ByteBuffer)
     */
    public void deliverMsg(ByteBuffer msgBuffer) {
        try {
            //get the vote
            voteSize = msgBuffer.getShort();
            vote = new String(msgBuffer.array(), 2, voteSize);
            
            //open connection and set it up
            connection = (HttpURLConnection)url.openConnection();
            connection.setRequestMethod("POST");
            connection.setDoOutput(true);
            
            //send the vote
            connection.getOutputStream().write(("senha=farnelpwd&voto=" + vote).getBytes());
            
            //ensure data send
            fooInt = connection.getInputStream().read();
        }
        catch (IOException ex) {
            errorReport.println("IO Exception occurred during vote delivery. Details: " + ex.getMessage());
        }
    }
}