/******************************************************************************

JMixNet - A Java MixNet Implementation

Fabiano Castro Pereira
LabSEC - Computer Security Laboratory (www.labsec.ufsc.br)
Informatics and Statistics Department (www.inf.ufsc.br)
Federal University of Santa Catarina  (www.ufsc.br)  
Florianopolis, Santa Catarina, Brazil

JMixNet is a registered trademark of the Federal University of Santa Catarina.
No commercial use of this trademark may be made without prior written
permission of the Federal University of Santa Catarina.\

******************************************************************************/
package br.edu.ufsc.labsec.jmixnet.example;

import java.io.*;
import java.net.*;
import javax.net.ServerSocketFactory;

/**
 * @author castro
 *
 * Example server to show the receiving of messages through the JMixNet.
 */
public class ReceiverServer {

    public static void main(String[] args) {
        ServerSocketFactory factory = ServerSocketFactory.getDefault();
        Socket clientCon;
        InputStream cliInput;
        byte[] msgBuf = new byte[4096];
        ServerSocket server = null;
        int amountRead;        
        
        System.out.println("Receiver server running.");
        
        try {
            server = factory.createServerSocket(2000);
        }
        catch (IOException e) {
            e.printStackTrace();
        }
        while (true) {
            //start server and wait for connection
            try {
                clientCon = server.accept();
                cliInput = clientCon.getInputStream();
            
                //System.out.print("[");
                while ((amountRead = cliInput.read(msgBuf)) > 0) {
                    //System.out.write(msgBuf, 0, amountRead);
                }
                //System.out.println("]");
                clientCon.close();
            }
            catch (IOException e1) {
                e1.printStackTrace();
            }
        }
    }
}